// //v:10 /t:library /out:TaskScheduler.dll cotaskmem.cs cominterfacewrapper.cs cominterfaces.cs task.cs /nowarn:169
using System;
using System.Collections;
#if !V10 && !V11
using System.Collections.Generic;
#endif
using System.ComponentModel;
using System.IO;
using System.Runtime.InteropServices;
#if !V10 && !V11
using System.Runtime.InteropServices.ComTypes;
#endif
using HongliangSoft.Utilities.TaskSchedulers.Interop;
using HongliangSoft.Utilities.Unmanaged;
using HongliangSoft.Utilities.Unmanaged.ComHelpers;

namespace HongliangSoft.Utilities.TaskSchedulers {
	///<summary>^XNXPW[\A^XNACeǗNXłB</summary>
	public sealed class TaskScheduler : ComInterfaceWrapper {
		///<summary>
		///<see cref="TaskScheduler"/> ̐VCX^X܂B
		///</summary>
		public TaskScheduler() : base(new TaskSchedulerClass()) {
		}
		//private TaskSchedulerClass scheduler { get { return (TaskSchedulerClass)base.Instance; } }
		private ITaskScheduler ITaskScheduler { get { return (ITaskScheduler)base.Instance; } }
		///<summary>̃CX^X{̑ΏۂƂRs[^̖O擾܂͐ݒ肵܂B</summary>
		///<value>ΏۂƂRs[^ UNC A܂ null Bnull w肵ꍇA[J̃Rs[^Ӗ܂B</value>
		///<exception cref="COMException">FȂ HRESULT Ԃ܂B</exception>
		///<remarks>
		///  <para>[g̃Rs[^̃^XN𑀍삷ꍇÃRs[^̊ǗĂȂ΂Ȃ܂B</para>
		///</remarks>
		public string TargetComputer {
			get {
				IntPtr ptr;
				base.CheckHR(this.ITaskScheduler.GetTargetComputer(out ptr));
				using (CoTaskMem mem = ptr) {
					return mem.ReadString(CharSet.Unicode);
				}
			}
			set {
				base.CheckHR(this.ITaskScheduler.SetTargetComputer(value));
			}
		}
		///<summary>
		///w肵Õ^XNACe폜܂B
		///</summary>
		///<param name="taskName">폜^XNACe̖OB</param>
		///<returns>폜ɐꍇ true Bt@C݂ĂȂ false B</returns>
		///<exception cref="ArgumentNullException"><paramref name="taskName"/>  null w肳܂B</exception>
		///<exception cref="FileNotFoundException"><paramref name="taskName"/> Ŏw肵Õ^XNACewt@C܂B</exception>
		///<exception cref="DirectoryNotFoundException"><paramref name="taskName"/> Ŏw肵OȃpX܂݂܂B</exception>
		///<exception cref="COMException">FȂ HRESULT Ԃ܂B</exception>
		public bool DeleteTask(string taskName) {
			if (taskName == null)
				throw new ArgumentNullException("taskName", "taskName  null Ɏw肷邱Ƃ͂ł܂B");
			HResult hr = this.ITaskScheduler.Delete(taskName);
			if (hr == HResult.CorFileNotFound)
				return false;
			base.CheckHR(hr);
			return true;
		}
		///<summary>
		///SẴ^XNACe̖O̔z擾܂B
		///</summary>
		///<returns>^XNACe̖Oi[Ă String ̔zB</returns>
		///<exception cref="COMException">FȂ HRESULT Ԃ܂B</exception>
		public string[] GetTaskNames() {
			IEnumWorkItems enumerator;
			base.CheckHR(this.ITaskScheduler.Enum(out enumerator));
			using (new ComInterfaceWrapper(enumerator)) {
#if !V10 && !V11
				List<string> tasks = new List<string>();
#else
				ArrayList tasks = new ArrayList();
#endif
				IntPtr item;
				HResult result;
				while ((result = enumerator.Next(1, out item, IntPtr.Zero)) == HResult.OK) {
					//Ԃ͕̂ւ̃|C^̔zivf1jB
					//̃|C^z񂩂擪̗vf|C^Ƃēǂ݂ƂB
					using (CoTaskMem array = item,
#if !V10 && !V11
							 mem = array.ReadStructure<IntPtr>()
#else
							 mem = (IntPtr)array.ReadStructure(typeof(IntPtr))
#endif
							 ) {
						//t@CԂ̂ŁAgqr
						string read = mem.ReadString(CharSet.Unicode);
						Console.WriteLine(read);
						tasks.Add(Path.GetFileNameWithoutExtension(read));
					}
				}
				// Ōオ HResult.False ȊȌꍇ͉炩̒vIG[̉\
				if (result != HResult.False) {
					base.CheckHR(result);
				}
#if !V10 && !V11
				return tasks.ToArray();
#else
				return (string[])tasks.ToArray(typeof(string));
#endif
			}
		}
		private static Guid ITaskIid = new Guid("148BD524-A2AB-11CE-B11F-00AA00530503");
		private static Guid CTaskClsid = new Guid("148BD520-A2AB-11CE-B11F-00AA00530503");
		///<summary>
		///w肵Õ^XNACe擾܂B
		///</summary>
		///<param name="taskName">擾^XNACe̖OB</param>
		///<returns>擾^XNACe\ <see cref="Task"/> B</returns>
		///<exception cref="ArgumentNullException"><paramref name="taskName"/>  null w肳܂B</exception>
		///<exception cref="FileNotFoundException"><paramref name="taskName"/> Ŏw肵Õ^XNACewt@C܂B</exception>
		///<exception cref="DirectoryNotFoundException"><paramref name="taskName"/> Ŏw肵OȃpX܂݂܂B</exception>
		///<exception cref="COMException">FȂ HRESULT Ԃ܂B</exception>
		public Task GetTask(string taskName) {
			if (taskName == null)
				throw new ArgumentNullException("taskName", "^XNACe̖O null ɂ邱Ƃ͂ł܂B");
			ITask task;
			base.CheckHR(this.ITaskScheduler.Activate(taskName, ref TaskScheduler.ITaskIid, out task));
			return new Task(task);
		}
		///<summary>
		///w肵Õ^XNACe쐬܂B
		///</summary>
		///<param name="taskName">쐬^XNACe̖OB</param>
		///<returns>쐬^XNACe\ <see cref="Task"/> B</returns>
		///<exception cref="ArgumentNullException"><paramref name="taskName"/>  null w肳܂B</exception>
		///<exception cref="DirectoryNotFoundException"><paramref name="taskName"/> Ŏw肵OȃpX܂݂܂B</exception>
		///<exception cref="COMException">FȂ HRESULT Ԃ܂B</exception>
		public Task CreateTask(string taskName) {
			if (taskName == null)
				throw new ArgumentNullException("taskName", "^XNACe̖O null ɂ邱Ƃ͂ł܂B");
			ITask iTask;
			HResult result = this.ITaskScheduler.NewWorkItem(taskName, ref TaskScheduler.CTaskClsid, ref TaskScheduler.ITaskIid, out iTask);
			if (result == HResult.OK) {
				Task task = new Task(iTask);
				task.Save();
				return task;
			}
			else if (result == HResult.FileExists)
				throw new IOException("̃t@Cɑ݂Ă܂B");
			else
				base.CheckHR(result);
			// ɂ͗Ȃ
			return null;
		}
	}
}