using System;
using System.Runtime.InteropServices;

namespace HongliangSoft.Utilities.Unmanaged {
	///<summary>A}l[WhƂ̑݉^pŎgp邽߂́ASYSTEMTIME \̂̃}l[WhNXłB</summary>
	[StructLayout(LayoutKind.Sequential, Pack=2)]
	public class SystemTimeClass : IFormattable, IComparable
#if !V10 && !V11
		, IComparable<SystemTimeClass>, IEquatable<SystemTimeClass>
#endif
	{
		///<summary>̃CX^X\t̔N̕擾܂B</summary>
		public short Year { get { return this.year; } }
		///<summary>̃CX^X\ť̕擾܂B</summary>
		public short Month { get { return this.month; } }
		///<summary>̃CX^X\t̗j\ <see cref="DayOfWeek"/> ̒l擾܂B</summary>
		public short DayOfWeek { get { return this.dayOfWeek; } }
		///<summary>̃CX^X\t̓̕擾܂B</summary>
		public short Day { get { return this.day; } }
		///<summary>̃CX^X\t̎Ԃ̕擾܂B</summary>
		public short Hour { get { return this.hour; } }
		///<summary>̃CX^X\t̕̕擾܂B</summary>
		public short Minute { get { return this.minute; } }
		///<summary>̃CX^X\t̕b̕擾܂B</summary>
		public short Second { get { return this.second; } }
		///<summary>̃CX^X\t̃~b̕擾܂B</summary>
		public short Millisecond { get { return this.millisecond; } }
		///<summary>
		///̃CX^X̒lA̕\ɕϊ܂B
		///</summary>
		///<returns>̃CX^XƓ̕\B</returns>
		///<remarks>
		///  <para>ԂĺÃCX^XƓ <see cref="DateTime"/> ́A<see cref="DateTime.ToString()"/> ̌ʂƓɂȂ܂B</para>
		///</remarks>
		public override string ToString() {
			return this.ToDateTime().ToString();
		}
		///<summary>
		///̃CX^X̒lAw蕶gpē̕\ɕϊ܂B
		///</summary>
		///<param name="format">ϊɎgp鏑w蕶B</param>
		///<returns>̃CX^XƓ̕\B</returns>
		///<remarks>
		///  <para>ԂĺÃCX^XƓ <see cref="DateTime"/> ́A<see cref="DateTime.ToString(string)"/> ̌ʂƓɂȂ܂B</para>
		///</remarks>
		public string ToString(string format) {
			return this.ToDateTime().ToString(format);
		}
		///<summary>
		///̃CX^X̒lAw蕶ƃJ`ŗL̏gpē̕\ɕϊ܂B
		///</summary>
		///<param name="format">ϊɎgp鏑w蕶B</param>
		///<param name="provider">ϊɎgpJ`ŗL̏񋟂 <see cref="IFormatProvider"/> B</param>
		///<returns>̃CX^XƓ̕\B</returns>
		///<remarks>
		///  <para>ԂĺÃCX^XƓ <see cref="DateTime"/> ́A<see cref="DateTime.ToString(string, IFormatProvider)"/> ̌ʂƓɂȂ܂B</para>
		///</remarks>
		public string ToString(string format, IFormatProvider provider) {
			return this.ToDateTime().ToString(format, provider);
		}
		///<summary>
		///̃CX^X̃nbVR[hԂ܂B
		///</summary>
		///<returns>̃CX^X̃nbVR[hB</returns>
		public override int GetHashCode() {
			return unchecked((int)this.LocalValue);
		}
		///<summary>
		///̃CX^XƔrēǂ𔻒f܂B
		///</summary>
		///<param name="value">ǂ𔻒fIuWFNgB</param>
		///<returns>ꍇ true B</returns>
		public override bool Equals(object value) {
			return this.Equals(value as SystemTimeClass);
		}
		///<summary>
		///̃CX^XƔrēǂ𔻒f܂B
		///</summary>
		///<param name="value">ǂ𔻒f <see cref="SystemTimeClass"/> B</param>
		///<returns>ꍇ true B</returns>
		public bool Equals(SystemTimeClass value) {
			if (value == null)
				return false;
			return this.LocalValue == value.LocalValue;
		}
		// ep[^LXgvlonglB
		private long LocalValue {
			get {
				if (this.IsInvalid)
					throw new InvalidOperationException("CX^Xsȃp[^܂ł܂B");
				long year = this.Year, month = this.Month, day = this.Day;
				long hour = this.Hour, minute = this.Minute, second = this.Second, milli = this.Millisecond;
				return (year << 36) | (month << 32) | (day << 27) | (hour << 22) | (minute << 16) | (second << 10) | milli;
			}
		}
		///<summary>
		///݂̃IuWFNg𑼂̃IuWFNgƔr܂B
		///</summary>
		///<param name="value">rIuWFNgB</param>
		///<returns>rΏۃIuWFNg̑Ώ Int32 Bȉ̃p^[܂B
		///  <list type="table">
		///    <listheader><term>l</term><description>Ӗ</description></listheader>
		///    <item><term>0 菬l</term><description>̃IuWFNg <paramref name="value"/> 菬B</description></item>
		///    <item><term>0</term><description>̃IuWFNg <paramref name="value"/> ƓB</description></item>
		///    <item><term>0 傫l</term><description>̃IuWFNg <paramref name="value"/> 傫B</description></item>
		///  </list>
		///</returns>
		///<exception cref="ArgumentException"><paramref name="value"/>  <see cref="SystemTimeClass"/> ̃CX^Xł͂܂B</exception>
		int IComparable.CompareTo(object value) {
			if (value == null)
				return 1;
			SystemTimeClass time = value as SystemTimeClass;
			if (time == null)
				throw new ArgumentException("IuWFNg SystemTimeClass ^łȂ΂Ȃ܂B", "value");
			return this.CompareTo(time);
		}
		///<summary>
		///݂̃IuWFNg𑼂̃IuWFNgƔr܂B
		///</summary>
		///<param name="value">rIuWFNgB</param>
		///<returns>rΏۃIuWFNg̑Ώ Int32 Bȉ̃p^[܂B
		///  <list type="table">
		///    <listheader><term>l</term><description>Ӗ</description></listheader>
		///    <item><term>0 菬l</term><description>̃IuWFNg <paramref name="value"/> 菬B</description></item>
		///    <item><term>0</term><description>̃IuWFNg <paramref name="value"/> ƓB</description></item>
		///    <item><term>0 傫l</term><description>̃IuWFNg <paramref name="value"/> 傫B</description></item>
		///  </list>
		///</returns>
		public int CompareTo(SystemTimeClass value) {
			if (value == null)
				return 1;
			long diff = this.LocalValue - value.LocalValue;
			return (diff > 0) ? 1 : (diff < 0) ? -1 : 0;
		}
		///<summary>
		/// <see cref="SystemTimeClass"/> CX^X̑召r܂B
		///</summary>
		///<param name="time1">rIuWFNgB</param>
		///<param name="time2">rIuWFNgB</param>
		///<returns>rΏۃIuWFNg̑Ώ Int32 Bȉ̃p^[܂B
		///  <list type="table">
		///    <listheader><term>l</term><description>Ӗ</description></listheader>
		///    <item><term>0 菬l</term><description><paramref name="time1"/>  <paramref name="time2"/> 菬B</description></item>
		///    <item><term>0</term><description><paramref name="time1"/>  <paramref name="time2"/> ƓB</description></item>
		///    <item><term>0 傫l</term><description><paramref name="time1"/>  <paramref name="time2"/> 傫B</description></item>
		///  </list>
		///</returns>
		public static int Compare(SystemTimeClass time1, SystemTimeClass time2) {
			return time1.CompareTo(time2);
		}
		///<summary>
		///̃CX^XA <see cref="DateTime"/> ɕϊ܂B
		///</summary>
		///<returns>̃CX^XƓ <see cref="DateTime"/> B</returns>
		public DateTime ToDateTime() {
			return new DateTime(this.Year, this.Month, this.Day, this.Hour,
									  this.Minute, this.Second, this.Millisecond);
		}
		///<summary>
		///<see cref="SystemTimeClass"/> ̃CX^XA<see cref="DateTime"/> ɕϊ܂B
		///</summary>
		///<param name="time">ϊ <see cref="SystemTimeClass"/> B</param>
		///<returns><paramref name="time"/> Ɠ <see cref="DateTime"/> B</returns>
		public static implicit operator DateTime(SystemTimeClass time) {
			return time.ToDateTime();
		}
		///<summary>
		///<see cref="DateTime"/> ̃CX^XA<see cref="SystemTimeClass"/> ɕϊ܂B
		///</summary>
		///<param name="time">ϊ <see cref="DateTime"/> B</param>
		///<returns><paramref name="time"/> Ɠ <see cref="DateTime"/> BA<see cref="SystemTimeClass"/> ̓~blȂ߁A~bPʂlɂĂ͖܂B</returns>
		public static implicit operator SystemTimeClass(DateTime time) {
			return new SystemTimeClass(time);
		}
		///<summary>̃CX^XԂwĂ邩ǂ𔻒fl擾܂B</summary>
		///<value>̃CX^XsȎԂwĂꍇ true B</value>
		///<remarks>
		///  <para>̒l true ԂꍇÃ\bhvpeB̌ĂяoɎs\܂B</para>
		///</remarks>
		public bool IsInvalid {
			get {
				if (this.year < 1 || this.year > 9999)
					return true;
				if (this.month < 1 || this.month > 12)
					return true;
				if (this.day < 0 || this.day > DateTime.DaysInMonth(this.year, this.month))
					return true;
				if (this.hour < 0 || this.hour > 23)
					return true;
				if (this.minute < 0 || this.minute > 59)
					return true;
				if (this.second < 0 || this.second > 59)
					return true;
				if (this.millisecond < 0 || this.millisecond > 999)
					return true;
				return false;
			}
		}
		///<summary>
		///CX^X܂B
		///</summary>
		private SystemTimeClass() { }
		///<summary>
		///NAAw肵ăCX^X܂B
		///</summary>
		///<param name="year">N\lB</param>
		///<param name="month">\lB</param>
		///<param name="day">\lB</param>
		///<exception cref="ArgumentOutOfRangeException">ꂩ̈ȂlłB</exception>
		public SystemTimeClass(int year, int month, int day) : this(year, month, day, 0, 0, 0) { }
		///<summary>
		///NAAAԁAAbw肵ăCX^X܂B
		///</summary>
		///<param name="year">N\lB</param>
		///<param name="month">\lB</param>
		///<param name="day">\lB</param>
		///<param name="hour">Ԃ\lB</param>
		///<param name="minute">\lB</param>
		///<param name="second">b\lB</param>
		///<exception cref="ArgumentOutOfRangeException">ꂩ̈ȂlłB</exception>
		public SystemTimeClass(int year, int month, int day, int hour, int minute, int second) : this(year, month, day, hour, minute, second, 0) { }
		///<summary>
		///NAAAԁAAbA~bw肵ăCX^X܂B
		///</summary>
		///<param name="year">N\lB</param>
		///<param name="month">\lB</param>
		///<param name="day">\lB</param>
		///<param name="hour">Ԃ\lB</param>
		///<param name="minute">\lB</param>
		///<param name="second">b\lB</param>
		///<param name="millisecond">~b\lB</param>
		///<exception cref="ArgumentOutOfRangeException">ꂩ̈ȂlłB</exception>
		public SystemTimeClass(int year, int month, int day, int hour, int minute, int second, int millisecond) {
			if (year < 1 || year > 9999)
				throw new ArgumentOutOfRangeException("year", year, "1  9999 ܂ł̊ԂłȂ΂Ȃ܂B");
			if (month < 1 || month > 12)
				throw new ArgumentOutOfRangeException("month", month, "1  12 ܂ł̊ԂłȂ΂Ȃ܂B");
			if (day < 0 || day > DateTime.DaysInMonth(year, month))
				throw new ArgumentOutOfRangeException("day", day, "̓t͎w肵NEɂ݂͑܂B");
			if (hour < 0 || hour > 23)
				throw new ArgumentOutOfRangeException("hour", hour, "0  23 ܂ł̊ԂłȂ΂Ȃ܂B");
			if (minute < 0 || minute > 59)
				throw new ArgumentOutOfRangeException("minute", minute, "0  59 ܂ł̊ԂłȂ΂Ȃ܂B");
			if (second < 0 || second > 59)
				throw new ArgumentOutOfRangeException("second", second, "0  59 ܂ł̊ԂłȂ΂Ȃ܂B");
			if (millisecond < 0 || millisecond > 999)
				throw new ArgumentOutOfRangeException("millisecond", millisecond, "0  999 ܂ł̊ԂłȂ΂Ȃ܂B");
			this.year = (short)year;
			this.month = (short)month;
			this.day = (short)day;
			this.hour = (short)hour;
			this.minute = (short)minute;
			this.second = (short)second;
			this.millisecond = (short)millisecond;
			this.dayOfWeek = (short)(int)new DateTime(year, month, day).DayOfWeek;
		}
		///<summary>
		///<see cref="DateTime"/> ̃CX^XɁA<see cref="SystemTimeClass"/> ̃CX^X܂B
		///</summary>
		///<param name="time">錳 <see cref="DateTime"/> B</param>
		///<remarks>
		///  <para><see cref="SystemTimeClass"/> ̓~blȂ߁A~bPʂlɂĂ͖܂B</para>
		///</remarks>
		public SystemTimeClass(DateTime time) : this(time.Year, time.Month, time.Day, time.Hour,
															 time.Minute, time.Second, time.Millisecond) {
		}
		///<summary>̃CX^X̍ŏ̒l\܂B</summary>
		///<value>̒ĺA 0001 N 1  1  00:00:00.000 ɑ܂B</value>
		public static readonly SystemTimeClass MinValue = new SystemTimeClass(1, 1, 1);
		///<summary>̃CX^X̍ő̒l\܂B</summary>
		///<value>̒ĺA 9999 N 12  31  23:59:59.999 ɑ܂B</value>
		public static readonly SystemTimeClass MaxValue = new SystemTimeClass(9999, 12, 31, 23, 59, 59, 999);
		private short year;
		private short month;
		private short dayOfWeek;
		private short day;
		private short hour;
		private short minute;
		private short second;
		private short millisecond;
	}
}
